package dev.shadowsoffire.apotheosis.adventure.affix.effect;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixType;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import java.util.function.Function;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.phys.Vec3;
import net.minecraftforge.event.entity.living.LivingDropsEvent;

public class TelepathicAffix extends Affix {
  public static final Codec<dev.shadowsoffire.apotheosis.adventure.affix.effect.TelepathicAffix> CODEC;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)LootRarity.CODEC.fieldOf("min_rarity").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.affix.effect.TelepathicAffix::new));
  }
  
  public static Vec3 blockDropTargetPos = null;
  
  protected LootRarity minRarity;
  
  public TelepathicAffix(LootRarity minRarity) {
    super(AffixType.ABILITY);
    this.minRarity = minRarity;
  }
  
  public boolean canApplyTo(ItemStack stack, LootCategory cat, LootRarity rarity) {
    return ((cat.isRanged() || cat.isLightWeapon() || cat.isBreaker()) && rarity.isAtLeast(this.minRarity));
  }
  
  public MutableComponent getDescription(ItemStack stack, LootRarity rarity, float level) {
    LootCategory cat = LootCategory.forItem(stack);
    String type = (cat.isRanged() || cat.isWeapon()) ? "weapon" : "tool";
    return Component.m_237115_("affix." + getId() + ".desc." + type);
  }
  
  public boolean enablesTelepathy() {
    return true;
  }
  
  public Codec<? extends Affix> getCodec() {
    return (Codec)CODEC;
  }
  
  public static void drops(LivingDropsEvent e) {
    // Byte code:
    //   0: aload_0
    //   1: invokevirtual getSource : ()Lnet/minecraft/world/damagesource/DamageSource;
    //   4: astore_1
    //   5: iconst_0
    //   6: istore_2
    //   7: aconst_null
    //   8: astore_3
    //   9: aload_1
    //   10: invokevirtual m_7640_ : ()Lnet/minecraft/world/entity/Entity;
    //   13: astore #6
    //   15: aload #6
    //   17: instanceof net/minecraft/world/entity/projectile/AbstractArrow
    //   20: ifeq -> 66
    //   23: aload #6
    //   25: checkcast net/minecraft/world/entity/projectile/AbstractArrow
    //   28: astore #4
    //   30: aload #4
    //   32: invokevirtual m_19749_ : ()Lnet/minecraft/world/entity/Entity;
    //   35: ifnull -> 66
    //   38: aload #4
    //   40: invokestatic streamAffixes : (Lnet/minecraft/world/entity/projectile/AbstractArrow;)Ljava/util/stream/Stream;
    //   43: <illegal opcode> test : ()Ljava/util/function/Predicate;
    //   48: invokeinterface anyMatch : (Ljava/util/function/Predicate;)Z
    //   53: istore_2
    //   54: aload #4
    //   56: invokevirtual m_19749_ : ()Lnet/minecraft/world/entity/Entity;
    //   59: invokevirtual m_20182_ : ()Lnet/minecraft/world/phys/Vec3;
    //   62: astore_3
    //   63: goto -> 116
    //   66: aload_1
    //   67: invokevirtual m_7640_ : ()Lnet/minecraft/world/entity/Entity;
    //   70: astore #6
    //   72: aload #6
    //   74: instanceof net/minecraft/world/entity/LivingEntity
    //   77: ifeq -> 116
    //   80: aload #6
    //   82: checkcast net/minecraft/world/entity/LivingEntity
    //   85: astore #5
    //   87: aload #5
    //   89: invokevirtual m_21205_ : ()Lnet/minecraft/world/item/ItemStack;
    //   92: astore #6
    //   94: aload #6
    //   96: invokestatic streamAffixes : (Lnet/minecraft/world/item/ItemStack;)Ljava/util/stream/Stream;
    //   99: <illegal opcode> test : ()Ljava/util/function/Predicate;
    //   104: invokeinterface anyMatch : (Ljava/util/function/Predicate;)Z
    //   109: istore_2
    //   110: aload #5
    //   112: invokevirtual m_20182_ : ()Lnet/minecraft/world/phys/Vec3;
    //   115: astore_3
    //   116: iload_2
    //   117: ifeq -> 179
    //   120: aload_0
    //   121: invokevirtual getDrops : ()Ljava/util/Collection;
    //   124: invokeinterface iterator : ()Ljava/util/Iterator;
    //   129: astore #4
    //   131: aload #4
    //   133: invokeinterface hasNext : ()Z
    //   138: ifeq -> 179
    //   141: aload #4
    //   143: invokeinterface next : ()Ljava/lang/Object;
    //   148: checkcast net/minecraft/world/entity/item/ItemEntity
    //   151: astore #5
    //   153: aload #5
    //   155: aload_3
    //   156: getfield f_82479_ : D
    //   159: aload_3
    //   160: getfield f_82480_ : D
    //   163: aload_3
    //   164: getfield f_82481_ : D
    //   167: invokevirtual m_6034_ : (DDD)V
    //   170: aload #5
    //   172: iconst_0
    //   173: invokevirtual m_32010_ : (I)V
    //   176: goto -> 131
    //   179: return
    // Line number table:
    //   Java source line number -> byte code offset
    //   #65	-> 0
    //   #66	-> 5
    //   #67	-> 7
    //   #68	-> 9
    //   #69	-> 38
    //   #70	-> 54
    //   #72	-> 66
    //   #73	-> 87
    //   #74	-> 94
    //   #75	-> 110
    //   #78	-> 116
    //   #79	-> 120
    //   #80	-> 153
    //   #81	-> 170
    //   #82	-> 176
    //   #84	-> 179
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   30	36	4	arrow	Lnet/minecraft/world/entity/projectile/AbstractArrow;
    //   94	22	6	weapon	Lnet/minecraft/world/item/ItemStack;
    //   87	29	5	living	Lnet/minecraft/world/entity/LivingEntity;
    //   153	23	5	item	Lnet/minecraft/world/entity/item/ItemEntity;
    //   0	180	0	e	Lnet/minecraftforge/event/entity/living/LivingDropsEvent;
    //   5	175	1	src	Lnet/minecraft/world/damagesource/DamageSource;
    //   7	173	2	canTeleport	Z
    //   9	171	3	targetPos	Lnet/minecraft/world/phys/Vec3;
  }
}
